unit AnaLex;{ Analizador Lxico }

interface

  uses General;
  const
     maxchar = 5000; maxkey = 631; maxint = 32767;

     integer0 = 1;
     boolean0 = 2; false0 = 3; true0 = 4;
     name0 = 5;
     counter0 = 6;
(*   input0 = 6; output0 = 7;    FELIX *)
     randomize0 = 8;
     read0 = 9; readln0 = 10;
     settime0 = 11 ; gettime0 = 12;
     debug0 = 13;
     write0 = 14; writeln0 = 15;
     broadcast0 = 16;

  type

     symboltype = (
                   and1,
                   andpersand1,
                   apostrophe1,
                   array1,
                   asterisk1,
                   becomes1,
                   begin1,
                   colon1,
                   comma1,
                   const1,
                   char1,
                   div1,
                   do1,
                   dotbecomes1,
		   doubledot1,
		   doublebar1,
                   downto1,
                   else1,
                   end1,
                   endtext1,
                   equal1,
                   for1,
                   greater1,
                   if1,
                   in1,
                   leftbracket1,
                   leftparenthesis1,
		   less1,
		   max1,
		   min1,
		   minus1,
                   mod1,
                   name1,
                   newline1,
                   not1,
                   notequal1,
                   notgreater1,
                   notless1,
                   numeral1,
                   of1,
                   or1,
                   parallel1,
                   period1,
                   plus1,
                   procedure1,
                   program1,
                   random1,
                   record1,
                   relax1,
                   repeat1,
                   rightbracket1,
                   rightparenthesis1,
                   segment1,
                   semicolon1,
                   set1,
                   shared1,
                   shl1,
                   shr1,
                   step1,
                   size1,
                   then1,
                   threshold1,
                   to1,
                   type1,
                   until1,
                   var1,
                   while1,
                   xor1,
                   unknown1);


  var
     names : word;

  procedure Analizador_Lexico;

implementation

const
   ETX = chr(3);
   NL = chr(10);
   TAB = char(9);
   SP = ' ';

   apostrophe = char(39);

   laststandardname = broadcast0;

type
   charset = set of char;

   spellingtable = array[1..maxchar] of char;

   wordpointer = ^wordrecord;

   wordrecord = record
                  nextword : wordpointer;
                  isname : boolean;
                  leng : byte;
                  index, lastchar : word
                end;

   hashtable = array[1..maxkey] of wordpointer;

var
   lineno : word;

   ch : char;

   alphanumeric,
   capitalletters,
   digits,
   invisible,
   letters,
   separators,
   smallletters : charset;

   spelling : spellingtable;

   characters : word;

   hash : hashtable;




   {INPUT}
procedure nextchar;
begin
  if EOF(finput) then ch := ETX
  else
    begin
       read(finput,ch);
       if ch in invisible then nextchar;
    end
end;

    {OUTPUT}

procedure emit1(symbol:symboltype);
begin
  emit( temp1, ord(symbol) );
end;

procedure emit2(symbol:symboltype; argument:longint);
begin
  emit( temp1, ord(symbol));
  emit( temp1,argument);
end;

    {WORD SYMBOLS AND NAMES}

function key( text : string ; leng : byte ) : word;
const
  W = 32641 {32768 - 127};
  N = maxkey;
var
  sum,i : word;
begin
  sum := 0;
  for i := 1 to leng do
    sum := (sum + ord(text[i]) mod W );
  key := sum mod N+1
end;

procedure insert( Isname:boolean; text:string; leng : byte ;
                  index, keyno:word);
var
 puntero:wordpointer;
 m,n:word;
begin

 {Insert the word in the spelling table}

 characters := characters + leng;

 testlimit(characters,maxchar);

 m := leng;
 n := characters - m;
 while m > 0 do
    begin
      spelling[m + n] := text[m];
      m := m - 1
    end;

 {Insert the word in the word list}
 new(puntero);
 puntero^.nextword := hash[keyno];
 puntero^.isname := isname;
 puntero^.index := index;
 puntero^.leng := leng;
 puntero^.lastchar := characters;
 hash[keyno] := puntero
end;

function found( text : string; leng : byte;
                puntero : wordpointer) :boolean;
var
 same:boolean;
 m,n:word;
begin
 if puntero^.leng <> leng then
    same := false
 else
    begin
      same := true;
      m := leng;
      n := puntero^.lastchar - m;
      while same and (m > 0) do
         begin
            same:= text[m] = spelling[m + n];
            m := m - 1
         end
    end;
 found := same
end;

procedure define( isname : boolean; text : string; leng,index : word);
begin
 insert( isname, text, leng, index, key(text,leng))
end;

procedure search(text: string; leng: word;
                 var isname: boolean; var index: word);
var
 keyno: word;
 puntero: wordpointer;
 done: boolean;
begin
 keyno := key(text , leng );
 puntero := hash[keyno];
 done := false;
 while not done do
    if puntero = nil then
      begin
        isname := true;
        names := names + 1;
        index := names;
        insert(true, text, leng, index, keyno);
        done := true
      end
    else
       if found(text, leng, puntero) then
          begin
             isname := puntero^.isname;
             index := puntero^.index;
             done := true
          end
       else
          puntero := puntero^.nextword
end;

procedure initialize;
var
 keyno:word;
begin
 digits := ['0'..'9'];
 capitalletters :=['A'..'Z',''];
 smallletters := ['a'..'z'] + [ '', '', '', '', '', ''];
 letters := capitalletters + smallletters;
 alphanumeric := letters + digits + ['_'];
 invisible := [chr(0)..chr(31)] + [chr(127)] - [TAB,NL,ETX];
 separators := [ SP, TAB, NL , '{', '(' ];

 { Se inicializa la tabla hash }
 keyno := 1;
 while keyno <= maxkey do
    begin
       hash[keyno] := nil ;
       keyno := keyno + 1
    end;

 characters := 0;

 {insert the word symbols}
 define( false,'and',3, ord(and1));
 define( false,'array',5, ord(array1));
 define( false,'begin',5, ord(begin1));
 define( false,'const',5, ord(const1));
 define( false,'div',3, ord(div1));
 define( false,'do',2, ord(do1));
 define( false,'downto',6,ord(downto1));
 define( false,'else',4, ord(else1));
 define( false,'end',3, ord(end1));
 define( false,'for',3,ord(for1));
 define( false,'if',2, ord(if1));
 define( false,'in',2, ord(in1));
 define( false,'max',3, ord(max1));
 define( false,'min',3, ord(min1));
 define( false,'mod',3, ord(mod1));
 define( false,'not',3, ord(not1));
 define( false,'of',2, ord(of1));
 define( false,'or',2, ord(or1));
 define( false,'parallel',8, ord(parallel1));
 define( false,'procedure',9, ord(procedure1));
 define( false,'program',7, ord(program1));
 define( false,'random',6, ord(random1));
 define( false,'relax',5, ord(relax1));
 define( false,'record',6, ord(record1));
 define( false,'repeat',6, ord(repeat1));
 define( false,'segment',7, ord(segment1));
 define( false,'set',3, ord(set1));
 define( false,'shared',6, ord(shared1));
 define( false,'shl',3, ord(shl1));
 define( false,'shr',3, ord(shr1));
 define( false,'size',4,ord(size1));
 define( false,'step',4,ord(step1));
 define( false,'then',4, ord(then1));
 define( false,'threshold',9, ord(threshold1));
 define( false,'to',2,ord(to1));
 define( false,'type',4, ord(type1));
 define( false,'until', 5, ord(until1));
 define( false,'var',3, ord(var1));
 define( false,'while',5, ord(while1));
 define( false,'xor',3, ord(xor1));

 {Insert the standard names}
 define( true,'integer',7,integer0);
 define( true,'boolean',7,boolean0);
 define( true, 'name',4, name0);
 define( true, 'counter',7, counter0);
 define( true,'false',5,false0);
 define( true,'true',4,true0);
(* define( true,'input',5,input0); *)
(* define( true,'output',6,output0);   *)
 define( true,'randomize',9, randomize0);
 define( true,'read',4,read0);
 define( true, 'readln',6, readln0);
 define( true,'settime',7, settime0);
 define( true,'gettime',7, gettime0);
 define( true,'debug',5, debug0);
 define( true,'write',5,write0);
 define( true,'writeln',7,writeln0);
 define( true,'broadcast',9,broadcast0);


 Names := laststandardname
end;

    { LEXICAL  ANALYSIS }

procedure beginline(number:word);
begin
 lineno := number;
 newline(lineno);
 emit2(newline1,lineno)
end;

procedure endline;
begin
 beginline(lineno + 1)
end;

procedure comment;
var
  endcomment : boolean;
begin
 {ch  = { or ch in (* }
 endcomment := false;
 nextchar;
 repeat
    if ch = '}' then
      begin
        nextchar;
        endcomment := true
      end
    else if ch = '*' then
      begin
        nextchar;
        if ch = ')' then
          begin
           endcomment := true;
           nextchar
          end
      end
    else if ch = '{' then comment
    else if ch = '(' then
      begin
        nextchar;
        if ch = '*' then comment;
      end
    else if ch = ETX then error(comment3)
    else
      begin
        if ch = NL then endline;
        nextchar;
      end
 until endcomment;
end;

procedure nextsymbol;
var
 isname: boolean;
 text : string;
 value : LongInt;
 leng, index, digit: word;
begin
 while ch in separators do
   if (ch = SP) or (ch = TAB) then nextchar
   else if ch = NL then
     begin
       endline;
       nextchar
     end
   else if ch = '(' then
     begin
       nextchar;
       if ch = '*' then comment
       else emit1(leftparenthesis1);
     end
   else  (* ch in { *) comment;
 if ch in letters then
  begin
   text := '';
   while ch in alphanumeric do
     begin
       if ch in capitalletters then
         ch := chr(ord(ch) + ord('a') - ord('A'));
         text := text + ch;
         nextchar
     end;
   leng := length( text );
   search(text ,leng,isname,index);
   if isname then emit2(name1,index)
   else emit( temp1, index)
  end
  else if ch in digits then
   begin
     value := 0;
     while ch in digits do
       begin
        digit := ord(ch) - ord('0');
        if value <= (maxlongint - digit) div 10 then
          begin
            value := 10 * value + digit;
            nextchar
          end
        else
          begin
           error(numeral3);
           while ch in digits do nextchar
          end
       end;
   emit2(numeral1,value)
  end
  else if ch = '+' then
   begin emit1(plus1); nextchar end
  else if ch = '-' then
   begin emit1(minus1); nextchar end
  else if ch = '*' then
   begin emit1(asterisk1); nextchar end
  else if ch = '&' then
   begin emit1(andpersand1); nextchar end
  else if ch = '<'then
   begin
     nextchar;
     if ch = '=' then
       begin emit1(notgreater1); nextchar end
     else if ch = '>'then
       begin emit1(notequal1); nextchar end
     else emit1(less1)
   end
  else if ch = '=' then
   begin emit1(equal1); nextchar end
  else if ch = '>' then
   begin
     nextchar;
     if ch = '='then
       begin emit1(notless1); nextchar end
     else emit1(greater1)
   end
  else if ch = ':' then
   begin
    nextchar;
    if ch = '=' then
      begin emit1(becomes1); nextchar end
    else emit1(colon1);
   end
  else if ch = '(' then
   begin
     nextchar;
     if ch = '*' then comment
     else emit1(leftparenthesis1);
   end
  else if ch = ')' then
   begin emit1(rightparenthesis1); nextchar end
   else if ch = '[' then
   begin emit1(leftbracket1); nextchar end
  else if ch = ']' then
   begin emit1(rightbracket1); nextchar end
  else if ch = ',' then
   begin emit1(comma1); nextchar end
  else if ch = '.' then
   begin
    nextchar;
	 if ch = '.' then
	  begin emit1(doubledot1); nextchar end
         else if ch = '=' then
           begin emit1(dotbecomes1); nextchar end
	 else emit1(period1)
	end
  else if ch = '|' then
	begin
	  nextchar;
	  if ch = '|' then
		 begin emit1(doublebar1); nextchar end
	  else begin emit1(unknown1); nextchar end
	end
  else if ch = ';'then
   begin emit1(semicolon1); nextchar end
  else if ch = apostrophe then
   begin
     emit1(apostrophe1);
     nextchar;
	  while (ch <> apostrophe) and ( ch <> ETX ) do
		 begin
			emit2( char1, ord(ch) );
			nextchar;
		 end;
	  if ch = apostrophe then
		 begin
			emit1(apostrophe1); nextchar;
		 end
	  else error(chain3)
	end
   else if ch <> ETX then
   begin emit1(unknown1); nextchar end
 end;


 procedure Analizador_Lexico;
 begin
    initialize;
    beginline(1);
    nextchar;
    while ch <> ETX do nextsymbol;
    emit1(endtext1);
 end;

 end.
