Unit ProcElem; { Instrucctions of Elemental Processors }

Interface

   Uses Crt, Dos, InsGame;

   Const

     SizeOfProgramStore : LongInt = ProgramMemorySize;

   Var

     StopPoint : LongInt;

     Implicit : Integer;

     ActualState : DebugState;

     PE : array[ ProcessorsRange] of Processor;

     St : ^ProgramStore;

     Running : boolean;

     finput : text;

   procedure  ReadLine( Var b: String);
   procedure  ShowProcessorState( ProcessorName : Integer );
   procedure  Error( ProcessorName : Integer; LineNo: LongInt; text:String);
   procedure  Add( ProcessorName : Integer );

   procedure  Andx( ProcessorName : Integer; Length : LongInt );

   procedure  AndIntx( ProcessorName : Integer);

   procedure  Assignx( ProcessorName : Integer; Length: LongInt);
   procedure  Constant( ProcessorName : Integer; Valor :LongInt);

   procedure  debug( ProcessorName : Integer );
   procedure  Divide( ProcessorName : Integer );
   procedure  EndBlock( ProcessorName : Integer );
   procedure  EndProc( ProcessorName : Integer; ParamLength: LongInt );

   procedure  Equal( ProcessorName : Integer; Length : LongInt);
   procedure  EqualInt(ProcessorName : Integer);

   procedure  Field( ProcessorName : Integer; Displ: LongInt);
   procedure  Fill( ProcessorName : Integer; Lower, Upper, Length, LineNo: LongInt);
   procedure  Fillzero( ProcessorName : Integer;  Length : LongInt);
   procedure  Free( ProcessorName : Integer; Size : LongInt);
   procedure  GetTimex( ProcessorName : Integer );


   procedure  GlobalCall( ProcessorName : Integer );
   procedure  GlobalCallThree( ProcessorName : Integer );
   procedure  GlobalCallTwo( ProcessorName : Integer );

   procedure  GlobalValue( ProcessorName : Integer; Displ: LongInt);
   procedure  GlobalValueTwo( ProcessorName : Integer; Displ: LongInt);
   procedure  GlobalValueThree( ProcessorName : Integer; Displ: LongInt);

   procedure  GlobalVar( ProcessorName : Integer; Displ: LongInt);
   procedure  GlobalVarTwo( ProcessorName : Integer; Displ: LongInt);
   procedure  GlobalVarThree( ProcessorName : Integer; Displ: LongInt);

   procedure  Greater( ProcessorName : Integer; Length : LongInt);
   procedure  GreaterInt( ProcessorName : Integer);

   procedure  Inx( ProcessorName : Integer;  Length : LongInt);
   procedure  Index( ProcessorName : Integer;
                     Lower, Upper, Length, LineNo: LongInt);

   procedure  Less(  ProcessorName : Integer; Length : LongInt);
   procedure  LessInt( ProcessorName : Integer);

   procedure  LocalCall( ProcessorName : Integer );

   procedure  LocalValue( ProcessorName : Integer; Displ: LongInt);
   procedure  LocalVar( ProcessorName : Integer; Displ: LongInt);
   procedure  Marked( ProcessorName : Integer;
		      Lower, Upper, Length, LineNo: LongInt);
   procedure  Minx( ProcessorName : Integer);
   procedure  Max( ProcessorName : Integer);
   procedure  Minus( ProcessorName : Integer ) ;
   procedure  Modulo( ProcessorName : Integer);
   procedure  Multiply( ProcessorName : Integer);
   procedure  NewBlock( ProcessorName : Integer; VarLength : LongInt);

   procedure  Notx( ProcessorName : Integer; Length : LongInt);
   procedure  NotInt( ProcessorName : Integer);
   procedure  NotEqual( ProcessorName : Integer; Length : LongInt);
   procedure  NotEqualInt( ProcessorName : Integer);
   procedure  NotGreater( ProcessorName : Integer; Length : LongInt);
   procedure  NotGreaterInt( ProcessorName : Integer);
   procedure  NotLess( ProcessorName : Integer; Length : LongInt);
   procedure  NotLessInt( ProcessorName : Integer);
   procedure  Orx( ProcessorName : Integer;  Length : LongInt );
   procedure  OrInt( ProcessorName : Integer);

   procedure  PopPattern(ProcessorName : Integer);
   procedure  ProcCall( ProcessorName : Integer; Level : LongInt );
   procedure  Procedurex( ProcessorName : Integer; VarLength : LongInt);
   procedure  Programx( ProcessorName : Integer; Names : LongInt);
   procedure  PushName( ProcessorName : Integer; LineNo: LongInt);
   procedure  PushPattern( ProcessorName : Integer);
   procedure  Randomx( Processorname : Integer; Length : LongInt);
   procedure  Randomizex( Processorname : Integer);
   procedure  Readx;
   procedure  Readlnx;
   procedure  SetTimex( ProcessorName : Integer );

   procedure  Shlx( ProcessorName : Integer;  Length : LongInt );
   procedure  ShlInt( ProcessorName : Integer);
   procedure  Shrx( ProcessorName : Integer;  Length : LongInt );
   procedure  ShrInt( ProcessorName : Integer);

   procedure  SimpleAssign( ProcessorName : Integer);
   procedure  SimpleValue( ProcessorName : Integer );
   procedure  Subtract( ProcessorName : Integer);
   procedure  Value( ProcessorName : Integer; Length: LongInt);
   procedure  Variable( ProcessorName : Integer; Level, Displ : LongInt);
   procedure  VarParam( ProcessorName : Integer; Level, Displ: LongInt);
   procedure  WriteIntx( ProcessorName : Integer);
   procedure  WriteStr( ProcessorName : Integer; Len, NumChar : LongInt);

   procedure  xOrx( ProcessorName : Integer;  Length : LongInt );
   procedure  XorInt( ProcessorName : Integer);

Implementation

  procedure ReadLine(Var b : String);
  Var r : regiSters;
      i : byte;
      buffer : array [byte] of char;
  begin
    buffer[0] := #255;
    with r do
    begin
      ah := $0a;
      ds := seg(buffer);
      dx := (Ofs(buffer));
      msdos(r);
    end;
    b[0] := buffer[1];
    for i := 1 to byte(buffer[1]) do
      b[i] := upcase(buffer[i+1]);
    Writeln;
  end;


  procedure  ShowProcessorState( ProcessorName : Integer );
  label GoOutFor;
  Var j : LongInt;
  begin
    with PE[ ProcessorName ] do
      begin
        if id = CtrlName then Write('CONTROL')
        else
          begin
            Write( id : 3, ' : ');
            Write('N '); highvideo; Write(Name:12); Normvideo;
          end;
        Write(': B '); highvideo; Write(b:6); Normvideo;
        Write(' S ');  highvideo; Write(s:6); Normvideo;
        for j := s downto s - 2 do
          begin
            if (j < 0) then goto GoOutFor
            else Write('|',St^[j]:12);
          end;
        GoOutFor:
          Writeln('|');
      end
  end;


  procedure  Error( ProcessorName : Integer; LineNo: LongInt; text:String);
  begin
    with PE[ProcessorName] do
      begin
        Write('Error. Processor : ',id:3, 'N ':3);
        highvideo; Write( Name:3 ); Normvideo;
        Writeln( ' -> Linea',LineNo:5,' : ',text);
        Running := False;
        ActualState := TraceInto;
        ShowProcessorState( Name);
      end;
  end;

  procedure CalTime( var time : LongInt);
  var r : registers;
  begin
    r.ah := $00;
    Intr( $1A, r );
    with r do
      begin
        time := cx;
        time := (time shl 16) or dx;
      end;
  end; (* CalTime *)

  {          E L E M E N T A L        P R O C E S S O R S     }

  procedure  Add( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := St^[ s ]  + St^[ s + 1 ];
      end;
  end;


  procedure  Andx( ProcessorName : Integer; Length : LongInt );
  Var i, x : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s;
        s := s - Length;
        for i := Length - 1 downto 0 do
           St^[ s - i ] := St^[ s - i] and St^[ x - i ];
      end;
  end;

  procedure  AndIntx( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := St^[ s ]  and St^[ s + 1 ];
      end;
  end;

  procedure  Assignx( ProcessorName : Integer; Length: LongInt);
  Var x, y, i: LongInt;
  begin
    with  PE[ProcessorName] do
      begin
        s :=  s - Length - 1;
        x := St^[s + 1];
        y := s + 2;
        i := 0;
        while i < Length do
          begin
            St^[x + i] := St^[y + i];
            i := i + 1
          end;
      end;
  end;


  procedure  Constant( ProcessorName : Integer; Valor :LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1 ;
        St^[s] := Valor;
      end
  end;

  (* Nothing to do *)
  procedure debug( ProcessorName : Integer );
  var onOff : boolean;
  begin
    with PE[ProcessorName] do
      begin
        if St^[s] = 0 then onOff := FALSE
        else onOff := TRUE;
        s := s - 1;
        (*ActualState := traceInto; *)
      end;
  end; (* SetTime *)

  procedure  Divide( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        if St^[s+1] <> 0 then  St^[s] := St^[s] div St^[s + 1]
        else Error( ProcessorName, Implicit ,' Division by zero.');
      end;
  end;

  procedure  EndBlock( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        s := b - 1;
        b := St^[b + 1];
      end;
  end;

  procedure  EndProc( ProcessorName : Integer; ParamLength: LongInt );
  begin
    with PE[ProcessorName] do
      begin
        s := b - ParamLength - 1;
        b := St^[b + 1]
      end;
  end;


  procedure  Equal( ProcessorName : Integer; Length : LongInt);
  Var i, x, aux : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        s := s - 2*Length + 1;
        aux := 1;
        for i := 0 to Length - 1 do
           aux := aux and ord(St^[s + i] = St^[x + i]);
        St^[s] := aux;
      end;
  end;

  procedure  EqualInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] = St^[ s + 1 ] );
      end;
  end;

  procedure  Field  ( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        St^[s] := St^[s] + Displ
      end;
  end;

  procedure fillzero( ProcessorName : integer; Length : longint);
  var i : integer;
  begin
    with PE[ProcessorName] do
      begin
	for i := 1 to length do
	  St^[s + i] := 0;
	s := s + length;
      end;
  end;

  procedure  Fill  ( ProcessorName:Integer; lower, Upper, Length, LineNo: LongInt);
  Var x, y, i, Displ, n : LongInt;
  begin
    with PE[ProcessorName] do
      begin
	x := St^[s - 1];
	y := St^[s];
	s := s - 2 ;
	if ( ( x < Lower ) or ( x > Upper ) ) or
	   ( ( y < Lower ) or ( y > Upper ) )  then
	  Error( ProcessorName, LineNo, ' Elemento fuera del conjunto.')
	else
	  begin
	    for i := 1 to Length do
	      St^[s+i] := 0;
	    for i := x to y do
	      begin
	        Displ := (i div wordPRAM) + 1;
		n := i mod wordPRAM;
		St^[s + Displ] := St^[s + Displ] or ( longint(1) Shl n );
	      end;
	    s := s + Length;
	  end
      end
  end;

  procedure  Free( ProcessorName : Integer; Size : LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s - Size;
      end;
  end;

  procedure GetTimex( ProcessorName : Integer );
  var time : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        calTime( time );
        St^[ St^[s-1] ] := time - St^[s];
        s := s - 2;
      end;
  end; (* GetTime *)

  procedure  GlobalCall( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        St^[s + 1] := St^[b];
        St^[s + 2] := b;
        b := s + 1;
        s := b + 2;
      end;
  end;

  procedure  GlobalCallTwo( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        St^[s + 1] := St^[St^[b]];
        St^[s + 2] := b;
        b := s + 1;
        s := b + 2;
      end;
  end;

  procedure  GlobalCallThree( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        St^[s + 1] := St^[St^[St^[b]]];
        St^[s + 2] := b;
        b := s + 1;
        s := b + 2;
      end;
  end;

  procedure  GlobalValue  ( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[ St^[b] + Displ];
      end;
  end;

  procedure  GlobalValueTwo( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[ St^[St^[b]] + Displ];
      end;
  end;

  procedure  GlobalValueThree( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[ St^[St^[St^[b]]] + Displ];
      end;
  end;

  procedure  GlobalVar  ( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[b] + Displ;
      end;
  end;

  procedure  GlobalVarTwo( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[St^[b]] + Displ;
      end;
  end;

  procedure  GlobalVarThree( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[St^[St^[b]]] + Displ;
      end;
  end;

  procedure  Greater( ProcessorName : Integer; Length : LongInt);
  Var i, x, aux : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        s := s - 2*Length + 1;
        aux := 1;
        for i := 0 to Length - 1 do
           aux := aux and ord(St^[s + i] > St^[x + i]);
        St^[s] := aux;
      end
  end;

  procedure  GreaterInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] > St^[ s + 1 ] );
      end;
  end;

  procedure  Inx( ProcessorName : Integer;  Length : LongInt);
  Var x, n , Displ : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        s := s - Length;
	x := St^[s];
	Displ := x div wordPRAM;
	n := x mod wordPRAM;
	St^[s] := LongInt( ( (longint(1) Shl n) and St^[ s + 1 + Displ ] ) <> 0 );
      end
  end;

  procedure  Index( ProcessorName : Integer; Lower, Upper, Length, LineNo: LongInt);
  Var i: LongInt;
  begin
    with PE[ProcessorName] do
      begin
        i := St^[s];
        s := s-1;;
        if (i < Lower) or (i >Upper) then
          Error( ProcessorName, LineNo, ' Index out of Range.')
        else
          St^[s] := St^[s] + (i - Lower) * Length;
      end
  end;

  procedure  Less(  ProcessorName : Integer; Length : LongInt);
  Var i, x, aux : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        s := s - 2*Length + 1;
        aux := 1;
        for i := 0 to Length - 1 do
           aux := aux and ord(St^[s + i] < St^[x + i]);
        St^[s] := aux;
      end;
  end;

  procedure  LessInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] < St^[ s + 1 ] );
      end;
  end;

  procedure  LocalCall( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        St^[s + 1] := b;
        St^[s + 2] := b;
        b := s + 1;
        s := b + 2;
      end;
  end;

  procedure  LocalValue( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := St^[b + Displ];
      end
  end;

  procedure  LocalVar( ProcessorName : Integer; Displ: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := b + Displ;
      end
  end;

  procedure  Marked( ProcessorName : Integer; Lower, Upper, Length, LineNo: LongInt);
  Var x, i, Displ, n : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := St^[s];
        s := s - 1;
	if ( x < Lower ) or ( x > Upper ) then
	   Error( ProcessorName, LineNo, ' Elemento fuera del conjunto.')
	else
	  begin
	    for i := 1 to Length do
	      St^[s+i] := 0;
	    Displ := x div wordPRAM;
	    n := x mod wordPRAM;
	    St^[s + 1 + Displ] := St^[s + 1 + Displ] or ( longint(1) Shl n );
	    s := s + Length
	  end
	end;
  end;

  procedure  Minx( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s-1;
	if St^[s] > St^[s+1] then  St^[s] :=  St^[s + 1];
      end
  end;


  procedure  Max( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
	s := s-1;
	if St^[s] < St^[s+1] then  St^[s] :=  St^[s + 1];
      end
  end;

  procedure  Minus( ProcessorName : Integer ) ;
  begin
    with PE[ProcessorName] do
      begin
        St^[s] := -St^[s];
      end
  end;

  procedure  Modulo( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s-1;
        if St^[s+1] <> 0 then  St^[s] := St^[s] mod St^[s + 1]
        else Error( ProcessorName, Implicit ,' Division by zero.');
      end
  end;

  procedure  Multiply( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s-1;
        St^[s] :=  St^[s] * St^[s + 1];
      end
  end;

  procedure  NewBlock( ProcessorName : Integer;  VarLength : LongInt);
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        St^[s] := b;
        St^[s + 1] := b;
        b := s;
        s := s + 2 + VarLength;
      end
  end;

  procedure  Notx( ProcessorName : Integer; Length : LongInt);
  Var i : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        for i := Length - 1 downto 0 do
          if St^[ s - i ] = 0 then   St^[ s - i ]:=1
          else  St^[ s - i ] := 0
      end
  end;

  procedure NotInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        if St^[ s ] = 0 then   St^[ s ] := 1
        else  St^[ s ] := 0
      end;
  end;


  procedure  NotEqual( ProcessorName : Integer; Length : LongInt);
  Var i, x, aux : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        s := s - 2*Length + 1;
        aux := 1;
        for i := 0 to Length - 1 do
           aux := aux and ord(St^[s + i] <> St^[x + i]);
        St^[s] := aux;
      end
  end;

  procedure  NotEqualInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] <> St^[ s + 1 ] );
      end;
  end;


  procedure  NotGreater( ProcessorName : Integer; Length : LongInt);
  Var i, x, aux : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        s := s - 2*Length + 1;
        aux := 1;
        for i := 0 to Length - 1 do
           aux := aux and ord(St^[s + i] <= St^[x + i]);
        St^[s] := aux;
      end
  end;

  procedure  NotGreaterInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] <= St^[ s + 1 ] );
      end;
  end;


  procedure  NotLess( ProcessorName : Integer; Length : LongInt);
  Var i, x, aux : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        s := s - 2*Length + 1;
        aux := 1;
        for i := 0 to Length - 1 do
           aux := aux and ord(St^[s + i] >= St^[x + i]);
        St^[s] := aux;
      end
  end;

  procedure  NotLessInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] >= St^[ s + 1 ] );
      end;
  end;


  procedure  Orx( ProcessorName : Integer;  Length : LongInt );
  Var i, x : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s;
        s := s - Length;
        for i := Length - 1 downto 0 do
           St^[ s - i ] := St^[ s - i] or St^[ x - i ];
      end
  end;

  procedure  OrInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := ord( St^[ s ] or St^[ s + 1 ] );
      end;
  end;


  procedure PopPattern(ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        b := St^[s];
        Name := St^[s-1];
        s := s-2;
      end;
  end;

  procedure  ProcCall( ProcessorName : Integer; Level : LongInt );
  Var x: LongInt;
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        x := b;
        while Level > 0 do
          begin
            x := St^[x];
            Level := Level - 1
          end;
        St^[s] := x;
        St^[s + 1] := b;
        b := s;
        s := b + 2;
      end;
  end;

  procedure  Procedurex( ProcessorName : Integer; VarLength : LongInt);
  begin
    with PE[ProcessorName] do
      s := s + VarLength;
  end;

  procedure  Programx( ProcessorName : Integer; Names: LongInt);
  begin
    with PE[ProcessorName] do
      begin
        id := Names;
        Name  :=  Names;
        b := 0;
        StackBottom := id * LocalStackSize + MemoryControlSize;
        s := StackBottom;
        St^[s] := 0;
        St^[s + 1] := 0;
        St^[s + 2] := 0;
      end;
  end;

  procedure  PushName( ProcessorName : Integer; LineNo : LongInt );
  begin
    with PE[ProcessorName] do
      begin
        if Name = -1 then
        Error( ProcessorName, LineNo, 'CONTROL to have go at PushName.')
        else
          begin
            s := s+1;
            St^[s] := Name;
          end
      end
  end;

  procedure  PushPattern( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        St^[s+1] := Name;
        St^[s+2] := b;
        s := s+2;
      end;
  end;

  procedure  Randomx( Processorname : Integer; Length : LongInt);
  begin
    with PE[ProcessorName] do
      St^[s] := random(St^[s]);
  end;

  procedure  Randomizex( Processorname : Integer);
  begin
    randomize;
  end;

  procedure  Readx;
  begin
    with PE[CtrlName] do
      begin
        TextBackGround(white); TextColor(black);
        read( finput, St^[St^[s]]);
        Normvideo;
        s := s-1;
      end
  end;

  procedure Readlnx;
  begin
    with PE[CtrlName] do
      begin
        TextBackGround(white); TextColor(black);
        readln;
        Normvideo;
      end
  end;

  procedure SetTimex( ProcessorName : Integer );
  var time : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        calTime( time );
        St^[ St^[s] ] := time;
        s := s - 1;
      end;
  end; (* SetTime *)

  procedure  Shlx( ProcessorName : Integer;  Length : LongInt );
  Var i, x, y : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        y := s - 2*Length + 1;
        s := s - Length;
        for i := 0 to Length - 1 do
           St^[ y + i ] := St^[ y + i] Shl St^[ x + i ];
      end
  end;

  procedure  ShlInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := St^[ s ] shl St^[ s + 1 ];
      end;
  end;


  procedure  Shrx( ProcessorName : Integer;  Length : LongInt );
  Var i, x, y : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        y := s - 2*Length + 1;
        s := s - Length;
        for i := 0 to Length - 1 do
           St^[ y + i ] := St^[ y + i] Shr St^[ x + i ];
      end
  end;

  procedure  ShrInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := St^[ s ] Shr St^[ s + 1 ];
      end;
  end;


  procedure  SimpleAssign( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        St^[St^[s - 1]] := St^[s];
        s := s-2;
      end
  end;

  procedure  SimpleValue( ProcessorName : Integer );
  begin
    with PE[ProcessorName] do
      begin
        St^[s] := St^[St^[s]];
      end
  end;

  procedure  Subtract( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s-1;
        St^[s] := St^[s] - St^[s + 1];
      end
  end;


  procedure  Value( ProcessorName : Integer; Length: LongInt);
  Var x, i : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := St^[s];
        i := 0;
        while i < Length do
          begin
            St^[s + i] := St^[x + i];
            i := i + 1
          end;
        s := s + Length - 1;
      end
  end;

  procedure  Variable( ProcessorName : Integer; Level, Displ : LongInt);
  Var  x: LongInt;
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        x := b;
        while Level > 0 do
          begin
            x := St^[x];
            Level := Level - 1
          end;
        St^[s] := x + Displ;
      end
  end;

  procedure  VarParam( ProcessorName : Integer; Level, Displ: LongInt);
  Var x: LongInt;
  begin
    with PE[ProcessorName] do
      begin
        s := s + 1;
        x := b;
        while Level > 0 do
          begin
            x := St^[x];
            Level := Level -1
          end;
        St^[s] := St^[x + Displ];
      end
  end;

  procedure  WriteIntx(ProcessorName : integer);
  begin
    with PE[ProcessorName] do
      begin
        TextBackGround (white); TextColor(black);
        if ProcessorName = CtrlName then Write(St^[s])
		else Writeln(id,':',St^[s]);
        Normvideo;
        s := s-1;
      end
  end;

  procedure  WriteStr( ProcessorName : Integer; Len, NumChar : LongInt);
  type
    packedChar = array[1..4] of byte;
  Var i ,j : word;
  begin
    with PE[ProcessorName] do
      begin
        TextBackGround(white);
        TextColor(black);
        for i := s - Len + 1 to s do
          begin
            j := 1;
            while (j <= numChar) and (j <= 4) do
              begin
                Write( char( packedChar(St^[i])[j] ) );
                j := j + 1;
              end;
            numChar := numChar - (j - 1);
          end;
        Normvideo;
        s := s - Len
      end
  end;

  procedure  xOrx( ProcessorName : Integer;  Length : LongInt );
  Var i, x, y : LongInt;
  begin
    with PE[ProcessorName] do
      begin
        x := s - Length + 1;
        y := s - 2*Length + 1;
        s := s - Length;
        for i := 0 to Length - 1 do
           St^[ y + i ] := St^[ y + i] xor St^[ x + i ];
      end
  end;

  procedure  XorInt( ProcessorName : Integer);
  begin
    with PE[ProcessorName] do
      begin
        s := s - 1;
        St^[s] := St^[ s ] xor St^[ s + 1 ];
      end;
  end;

end.
